# -*- coding: utf-8 -*-
# this file is generated by chinese_calendar.scripts.generate_constants
from __future__ import absolute_import, unicode_literals

import datetime
from enum import Enum


class Holiday(Enum):
    def __new__(cls, english, chinese, days):
        obj = object.__new__(cls)
        obj._value_ = english

        obj.chinese = chinese
        obj.days = days
        return obj

    new_years_day = "New Year's Day", "元旦", 1
    spring_festival = "Spring Festival", "春节", 3
    tomb_sweeping_day = "Tomb-sweeping Day", "清明", 1
    labour_day = "Labour Day", "劳动节", 1
    dragon_boat_festival = "Dragon Boat Festival", "端午", 1
    national_day = "National Day", "国庆节", 3
    mid_autumn_festival = "Mid-autumn Festival", "中秋", 1

    # special holidays
    anti_fascist_70th_day = "Anti-Fascist 70th Day", "中国人民抗日战争暨世界反法西斯战争胜利70周年纪念日", 1


holidays = {
    datetime.date(year=2019, month=1, day=1).strftime('%Y-%m-%d'): Holiday.new_years_day.value,
    datetime.date(year=2019, month=2, day=4).strftime('%Y-%m-%d'): Holiday.spring_festival.value,
    datetime.date(year=2019, month=2, day=5).strftime('%Y-%m-%d'): Holiday.spring_festival.value,
    datetime.date(year=2019, month=2, day=6).strftime('%Y-%m-%d'): Holiday.spring_festival.value,
    datetime.date(year=2019, month=2, day=7).strftime('%Y-%m-%d'): Holiday.spring_festival.value,
    datetime.date(year=2019, month=2, day=8).strftime('%Y-%m-%d'): Holiday.spring_festival.value,
    datetime.date(year=2019, month=2, day=9).strftime('%Y-%m-%d'): Holiday.spring_festival.value,
    datetime.date(year=2019, month=2, day=10).strftime('%Y-%m-%d'): Holiday.spring_festival.value,
    datetime.date(year=2019, month=4, day=5).strftime('%Y-%m-%d'): Holiday.tomb_sweeping_day.value,
    datetime.date(year=2019, month=4, day=6).strftime('%Y-%m-%d'): Holiday.tomb_sweeping_day.value,
    datetime.date(year=2019, month=4, day=7).strftime('%Y-%m-%d'): Holiday.tomb_sweeping_day.value,
    datetime.date(year=2019, month=5, day=1).strftime('%Y-%m-%d'): Holiday.labour_day.value,
    datetime.date(year=2019, month=5, day=2).strftime('%Y-%m-%d'): Holiday.labour_day.value,
    datetime.date(year=2019, month=5, day=3).strftime('%Y-%m-%d'): Holiday.labour_day.value,
    datetime.date(year=2019, month=5, day=4).strftime('%Y-%m-%d'): Holiday.labour_day.value,
    datetime.date(year=2019, month=6, day=7).strftime('%Y-%m-%d'): Holiday.dragon_boat_festival.value,
    datetime.date(year=2019, month=6, day=8).strftime('%Y-%m-%d'): Holiday.dragon_boat_festival.value,
    datetime.date(year=2019, month=6, day=9).strftime('%Y-%m-%d'): Holiday.dragon_boat_festival.value,
    datetime.date(year=2019, month=9, day=13).strftime('%Y-%m-%d'): Holiday.mid_autumn_festival.value,
    datetime.date(year=2019, month=9, day=14).strftime('%Y-%m-%d'): Holiday.mid_autumn_festival.value,
    datetime.date(year=2019, month=9, day=15).strftime('%Y-%m-%d'): Holiday.mid_autumn_festival.value,
    datetime.date(year=2019, month=10, day=1).strftime('%Y-%m-%d'): Holiday.national_day.value,
    datetime.date(year=2019, month=10, day=2).strftime('%Y-%m-%d'): Holiday.national_day.value,
    datetime.date(year=2019, month=10, day=3).strftime('%Y-%m-%d'): Holiday.national_day.value,
    datetime.date(year=2019, month=10, day=4).strftime('%Y-%m-%d'): Holiday.national_day.value,
    datetime.date(year=2019, month=10, day=5).strftime('%Y-%m-%d'): Holiday.national_day.value,
    datetime.date(year=2019, month=10, day=6).strftime('%Y-%m-%d'): Holiday.national_day.value,
    datetime.date(year=2019, month=10, day=7).strftime('%Y-%m-%d'): Holiday.national_day.value,
    datetime.date(year=2020, month=1, day=1).strftime('%Y-%m-%d'): Holiday.new_years_day.value,
    datetime.date(year=2020, month=1, day=24).strftime('%Y-%m-%d'): Holiday.spring_festival.value,
    datetime.date(year=2020, month=1, day=25).strftime('%Y-%m-%d'): Holiday.spring_festival.value,
    datetime.date(year=2020, month=1, day=26).strftime('%Y-%m-%d'): Holiday.spring_festival.value,
    datetime.date(year=2020, month=1, day=27).strftime('%Y-%m-%d'): Holiday.spring_festival.value,
    datetime.date(year=2020, month=1, day=28).strftime('%Y-%m-%d'): Holiday.spring_festival.value,
    datetime.date(year=2020, month=1, day=29).strftime('%Y-%m-%d'): Holiday.spring_festival.value,
    datetime.date(year=2020, month=1, day=30).strftime('%Y-%m-%d'): Holiday.spring_festival.value,
    datetime.date(year=2020, month=1, day=31).strftime('%Y-%m-%d'): Holiday.spring_festival.value,
    datetime.date(year=2020, month=2, day=1).strftime('%Y-%m-%d'): Holiday.spring_festival.value,
    datetime.date(year=2020, month=2, day=2).strftime('%Y-%m-%d'): Holiday.spring_festival.value,
    datetime.date(year=2020, month=4, day=4).strftime('%Y-%m-%d'): Holiday.tomb_sweeping_day.value,
    datetime.date(year=2020, month=4, day=5).strftime('%Y-%m-%d'): Holiday.tomb_sweeping_day.value,
    datetime.date(year=2020, month=4, day=6).strftime('%Y-%m-%d'): Holiday.tomb_sweeping_day.value,
    datetime.date(year=2020, month=5, day=1).strftime('%Y-%m-%d'): Holiday.labour_day.value,
    datetime.date(year=2020, month=5, day=2).strftime('%Y-%m-%d'): Holiday.labour_day.value,
    datetime.date(year=2020, month=5, day=3).strftime('%Y-%m-%d'): Holiday.labour_day.value,
    datetime.date(year=2020, month=5, day=4).strftime('%Y-%m-%d'): Holiday.labour_day.value,
    datetime.date(year=2020, month=5, day=5).strftime('%Y-%m-%d'): Holiday.labour_day.value,
    datetime.date(year=2020, month=6, day=25).strftime('%Y-%m-%d'): Holiday.dragon_boat_festival.value,
    datetime.date(year=2020, month=6, day=26).strftime('%Y-%m-%d'): Holiday.dragon_boat_festival.value,
    datetime.date(year=2020, month=6, day=27).strftime('%Y-%m-%d'): Holiday.dragon_boat_festival.value,
    datetime.date(year=2020, month=10, day=1).strftime('%Y-%m-%d'): Holiday.national_day.value,
    datetime.date(year=2020, month=10, day=2).strftime('%Y-%m-%d'): Holiday.national_day.value,
    datetime.date(year=2020, month=10, day=3).strftime('%Y-%m-%d'): Holiday.national_day.value,
    datetime.date(year=2020, month=10, day=4).strftime('%Y-%m-%d'): Holiday.national_day.value,
    datetime.date(year=2020, month=10, day=5).strftime('%Y-%m-%d'): Holiday.national_day.value,
    datetime.date(year=2020, month=10, day=6).strftime('%Y-%m-%d'): Holiday.national_day.value,
    datetime.date(year=2020, month=10, day=7).strftime('%Y-%m-%d'): Holiday.national_day.value,
    datetime.date(year=2020, month=10, day=8).strftime('%Y-%m-%d'): Holiday.national_day.value,
}

workdays = {
    datetime.date(year=2019, month=2, day=2).strftime('%Y-%m-%d'): Holiday.spring_festival.value,
    datetime.date(year=2019, month=2, day=3).strftime('%Y-%m-%d'): Holiday.spring_festival.value,
    datetime.date(year=2019, month=4, day=28).strftime('%Y-%m-%d'): Holiday.labour_day.value,
    datetime.date(year=2019, month=5, day=5).strftime('%Y-%m-%d'): Holiday.labour_day.value,
    datetime.date(year=2019, month=9, day=29).strftime('%Y-%m-%d'): Holiday.national_day.value,
    datetime.date(year=2019, month=10, day=12).strftime('%Y-%m-%d'): Holiday.national_day.value,
    datetime.date(year=2020, month=1, day=19).strftime('%Y-%m-%d'): Holiday.spring_festival.value,
    datetime.date(year=2020, month=4, day=26).strftime('%Y-%m-%d'): Holiday.labour_day.value,
    datetime.date(year=2020, month=5, day=9).strftime('%Y-%m-%d'): Holiday.labour_day.value,
    datetime.date(year=2020, month=6, day=28).strftime('%Y-%m-%d'): Holiday.dragon_boat_festival.value,
    datetime.date(year=2020, month=9, day=27).strftime('%Y-%m-%d'): Holiday.national_day.value,
    datetime.date(year=2020, month=10, day=10).strftime('%Y-%m-%d'): Holiday.national_day.value,
}
